searchNodes=[{"doc":"Apollo Federation support for Absinthe . Examples Schemas should use Absinthe.Federation.Schema defmodule MyApp.MySchema do use Absinthe.Schema + use Absinthe.Federation.Schema query do ... end end For a type module, use Absinthe.Federation.Notation instead: defmodule MyApp.MySchema.Types do use Absinthe.Schema.Notation + use Absinthe.Federation.Notation end","ref":"Absinthe.Federation.html","title":"Absinthe.Federation","type":"module"},{"doc":"","ref":"Absinthe.Federation.html#remove_federated_types_pipeline/1","title":"Absinthe.Federation.remove_federated_types_pipeline/1","type":"function"},{"doc":"","ref":"Absinthe.Federation.html#to_federated_sdl/1","title":"Absinthe.Federation.to_federated_sdl/1","type":"function"},{"doc":"Module that includes macros for annotating a schema with federation directives. Example defmodule MyApp.MySchema.Types do use Absinthe.Schema.Notation + use Absinthe.Federation.Notation end","ref":"Absinthe.Federation.Notation.html","title":"Absinthe.Federation.Notation","type":"module"},{"doc":"Adds the @extends directive to the type to indicate that the type as owned by another service. Example object :user do extends ( ) key_fields ( &quot;id&quot; ) field :id , non_null ( :id ) end SDL Output type User @key ( fields : &quot;id&quot; ) @extends { id : ID ! }","ref":"Absinthe.Federation.Notation.html#extends/0","title":"Absinthe.Federation.Notation.extends/0","type":"macro"},{"doc":"Adds the @external directive to the field which marks a field as owned by another service. This allows service A to use fields from service B while also knowing at runtime the types of that field. Example object :user do extends ( ) key_fields ( &quot;email&quot; ) field :email , :string do external ( ) end field :reviews , list_of ( :review ) end SDL Output # extended from the Users service type User @key ( fields : &quot;email&quot; ) @extends { email : String @external reviews : [ Review ] } This type extension in the Reviews service extends the User type from the Users service. It extends it for the purpose of adding a new field called reviews, which returns a list of Review s.","ref":"Absinthe.Federation.Notation.html#external/0","title":"Absinthe.Federation.Notation.external/0","type":"macro"},{"doc":"Adds a @key directive to the type which indicates a combination of fields that can be used to uniquely identify and fetch an object or interface. This allows the type to be extended by other services. A string rather than atom is used here to support composite keys e.g. id organization { id } Example object :user do key_fields ( &quot;id&quot; ) field :id , non_null ( :id ) end SDL Output type User @key ( fields : &quot;id&quot; ) { id : ID ! }","ref":"Absinthe.Federation.Notation.html#key_fields/1","title":"Absinthe.Federation.Notation.key_fields/1","type":"macro"},{"doc":"Adds the @provides directive which is used to annotate the expected returned fieldset from a field on a base type that is guaranteed to be selectable by the gateway. Example object :review do key_fields ( &quot;id&quot; ) field :id , non_null ( :id ) field :product , :product do provides_fields ( &quot;name&quot; ) end end object :product do extends ( ) key_fields ( &quot;upc&quot; ) field :upc , :string do external ( ) end field :name , :string do external ( ) end end SDL Output type Review @key ( fields : &quot;id&quot; ) { product : Product @provides ( fields : &quot;name&quot; ) } type Product @key ( fields : &quot;upc&quot; ) @extends { upc : String @external name : String @external } When fetching Review.product from the Reviews service, it is possible to request the name with the expectation that the Reviews service can provide it when going from review to product. Product.name is an external field on an external type which is why the local type extension of Product and annotation of name is required.","ref":"Absinthe.Federation.Notation.html#provides_fields/1","title":"Absinthe.Federation.Notation.provides_fields/1","type":"macro"},{"doc":"Adds the @requires directive which is used to annotate the required input fieldset from a base type for a resolver. It is used to develop a query plan where the required fields may not be needed by the client, but the service may need additional information from other services. Example object :user do extends ( ) key_fields ( &quot;id&quot; ) field :id , non_null ( :id ) do external ( ) end field :email , :string do external ( ) end field :reviews , list_of ( :review ) do requires_fields ( &quot;email&quot; ) end end SDL Output # extended from the Users service type User @key ( fields : &quot;id&quot; ) @extends { id : ID ! @external email : String @external reviews : [ Review ] @requires ( fields : &quot;email&quot; ) } In this case, the Reviews service adds new capabilities to the User type by providing a list of reviews related to a User . In order to fetch these reviews , the Reviews service needs to know the email of the User from the Users service in order to look up the reviews . This means the reviews field / resolver requires the email field from the base User type.","ref":"Absinthe.Federation.Notation.html#requires_fields/1","title":"Absinthe.Federation.Notation.requires_fields/1","type":"macro"},{"doc":"Module for injecting custom Absinthe.Phase s for adding federated types and directives. Example defmodule MyApp.MySchema do use Absinthe.Schema + use Absinthe.Federation.Schema query do ... end end","ref":"Absinthe.Federation.Schema.html","title":"Absinthe.Federation.Schema","type":"module"},{"doc":"Injects custom compile-time Absinthe.Phase","ref":"Absinthe.Federation.Schema.html#pipeline/1","title":"Absinthe.Federation.Schema.pipeline/1","type":"function"},{"doc":"https://www.apollographql.com/docs/federation/federation-spec/#query_service The federation schema modifications (i.e. new types and directive definitions) should not be included in this SDL.","ref":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.html","title":"Absinthe.Federation.Schema.Phase.AddFederatedTypes","type":"module"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.html#flag_invalid/1","title":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.flag_invalid/1","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.html#flag_invalid/2","title":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.flag_invalid/2","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.html#inherit_invalid/3","title":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.inherit_invalid/3","type":"function"},{"doc":"","ref":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.html#put_flag/2","title":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.put_flag/2","type":"function"},{"doc":"Callback implementation for Absinthe.Phase.run/2 .","ref":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.html#run/2","title":"Absinthe.Federation.Schema.Phase.AddFederatedTypes.run/2","type":"function"},{"doc":"Generate a schema.graphql file. Usage mix absinthe . schema . sdl [ OPTIONS ] [ FILENAME ] Options --schema - The name of the Absinthe.Schema module defining the schema to be generated. Default: As configured for :absinthe :schema Examples Write to default path ./schema.graphql using the :schema configured for the :absinthe application: mix absinthe.schema.sdl Write to path /path/to/schema.graphql using the MySchema schema mix absinthe.schema.sdl --schema MySchema /path/to/schema.graphql","ref":"Mix.Tasks.Absinthe.Federation.Schema.Sdl.html","title":"Mix.Tasks.Absinthe.Federation.Schema.Sdl","type":"task"},{"doc":"","ref":"Mix.Tasks.Absinthe.Federation.Schema.Sdl.html#generate_schema/1","title":"Mix.Tasks.Absinthe.Federation.Schema.Sdl.generate_schema/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Absinthe.Federation.Schema.Sdl.html#parse_options/1","title":"Mix.Tasks.Absinthe.Federation.Schema.Sdl.parse_options/1","type":"function"},{"doc":"Absinthe.Federation Apollo Federation support for Absinthe","ref":"readme.html","title":"Absinthe.Federation","type":"extras"},{"doc":"Install from Hex.pm : def deps do [ { :absinthe_federation , &quot;~&gt; 0.1.1&quot; } ] end Add the following line to your absinthe schema defmodule MyApp.MySchema do use Absinthe.Schema + use Absinthe.Federation.Schema query do ... end end","ref":"readme.html#installation","title":"Absinthe.Federation - Installation","type":"extras"},{"doc":"Macro based schemas (recommended) defmodule MyApp.MySchema do use Absinthe.Schema + use Absinthe.Federation.Schema query do + extends ( ) field :review , :review do arg ( :id , non_null ( :id ) ) resolve ( &amp; ReviewResolver . get_review_by_id / 3 ) end ... end object :product do + key_fields ( &quot;upc&quot; ) + extends ( ) field :upc , non_null ( :string ) do + external ( ) end field ( :reviews , list_of ( :review ) ) do resolve ( &amp; ReviewResolver . get_reviews_for_product / 3 ) end + field ( :_resolve_reference , :product ) do + resolve ( &amp; ProductResolver . get_product_by_upc / 3 ) + end end end SDL based schemas (experimental) defmodule MyApp.MySchema do use Absinthe.Schema + use Absinthe.Federation.Schema import_sdl &quot;&quot;&quot; extend type Query { review(id: ID!): Review } extend type Product @key(fields: &quot;upc&quot;) { upc: String! @external reviews: [Review] } &quot;&quot;&quot; def hydrate ( _ , _ ) do ... end","ref":"readme.html#usage","title":"Absinthe.Federation - Usage","type":"extras"},{"doc":"See additional documentation, including guides, in the Absinthe.Federation hexdocs .","ref":"readme.html#more-documentation","title":"Absinthe.Federation - More Documentation","type":"extras"},{"doc":"Refer to the Contributing Guide .","ref":"readme.html#contributing","title":"Absinthe.Federation - Contributing","type":"extras"},{"doc":"See LICENSE","ref":"readme.html#license","title":"Absinthe.Federation - License","type":"extras"},{"doc":"Contributing We want this community to be friendly and respectful to each other. Please follow it in all your interactions with the project.","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"To get started with the project, run mix deps.get in the root directory to install the required dependencies: $ mix deps.get Commit message convention We follow the conventional commits specification for our commit messages: fix : bug fixes, e.g. fix crash due to deprecated method. feat : new features, e.g. add new method to the module. refactor : code refactor, e.g. migrate from class components to hooks. docs : changes into documentation, e.g. add usage example for the module.. test : adding or updating tests, eg add integration tests using detox. chore : tooling changes, e.g. change CI config. Sending a pull request Working on your first pull request? You can learn how from this free series: How to Contribute to an Open Source Project on GitHub . When you're sending a pull request: Prefer small pull requests focused on one change. Verify that formatter and tests are passing. Review the documentation to make sure it looks good. Follow the pull request template when opening a pull request. For pull requests that change the API or implementation, discuss with maintainers first by opening an issue.","ref":"contributing.html#development-workflow","title":"Contributing - Development workflow","type":"extras"},{"doc":"Please remember that all interactions in our official spaces follow our Code of Conduct .","ref":"contributing.html#code-of-conduct","title":"Contributing - Code of Conduct","type":"extras"},{"doc":"License MIT License Copyright (c) 2021 DivvyPay, LLC Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"Code of Conduct","ref":"code_of_conduct.html","title":"Code of Conduct","type":"extras"},{"doc":"We as members, contributors, and leaders pledge to make participation in our community a harassment-free experience for everyone, regardless of age, body size, visible or invisible disability, ethnicity, sex characteristics, gender identity and expression, level of experience, education, socio-economic status, nationality, personal appearance, race, religion, or sexual identity and orientation. We pledge to act and interact in ways that contribute to an open, welcoming, diverse, inclusive, and healthy community.","ref":"code_of_conduct.html#our-pledge","title":"Code of Conduct - Our Pledge","type":"extras"},{"doc":"Examples of behavior that contributes to a positive environment for our community include: Demonstrating empathy and kindness toward other people Being respectful of differing opinions, viewpoints, and experiences Giving and gracefully accepting constructive feedback Accepting responsibility and apologizing to those affected by our mistakes, and learning from the experience Focusing on what is best not just for us as individuals, but for the overall community Examples of unacceptable behavior include: The use of sexualized language or imagery, and sexual attention or advances of any kind Trolling, insulting or derogatory comments, and personal or political attacks Public or private harassment Publishing others' private information, such as a physical or email address, without their explicit permission Other conduct which could reasonably be considered inappropriate in a professional setting","ref":"code_of_conduct.html#our-standards","title":"Code of Conduct - Our Standards","type":"extras"},{"doc":"Community leaders are responsible for clarifying and enforcing our standards of acceptable behavior and will take appropriate and fair corrective action in response to any behavior that they deem inappropriate, threatening, offensive, or harmful. Community leaders have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct, and will communicate reasons for moderation decisions when appropriate.","ref":"code_of_conduct.html#enforcement-responsibilities","title":"Code of Conduct - Enforcement Responsibilities","type":"extras"},{"doc":"This Code of Conduct applies within all community spaces, and also applies when an individual is officially representing the community in public spaces. Examples of representing our community include using an official e-mail address, posting via an official social media account, or acting as an appointed representative at an online or offline event.","ref":"code_of_conduct.html#scope","title":"Code of Conduct - Scope","type":"extras"},{"doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be reported to the community leaders responsible for enforcement at [INSERT CONTACT METHOD]. All complaints will be reviewed and investigated promptly and fairly. All community leaders are obligated to respect the privacy and security of the reporter of any incident.","ref":"code_of_conduct.html#enforcement","title":"Code of Conduct - Enforcement","type":"extras"},{"doc":"Community leaders will follow these Community Impact Guidelines in determining the consequences for any action they deem in violation of this Code of Conduct: 1. Correction Community Impact : Use of inappropriate language or other behavior deemed unprofessional or unwelcome in the community. Consequence : A private, written warning from community leaders, providing clarity around the nature of the violation and an explanation of why the behavior was inappropriate. A public apology may be requested. 2. Warning Community Impact : A violation through a single incident or series of actions. Consequence : A warning with consequences for continued behavior. No interaction with the people involved, including unsolicited interaction with those enforcing the Code of Conduct, for a specified period of time. This includes avoiding interactions in community spaces as well as external channels like social media. Violating these terms may lead to a temporary or permanent ban. 3. Temporary Ban Community Impact : A serious violation of community standards, including sustained inappropriate behavior. Consequence : A temporary ban from any sort of interaction or public communication with the community for a specified period of time. No public or private interaction with the people involved, including unsolicited interaction with those enforcing the Code of Conduct, is allowed during this period. Violating these terms may lead to a permanent ban. 4. Permanent Ban Community Impact : Demonstrating a pattern of violation of community standards, including sustained inappropriate behavior, harassment of an individual, or aggression toward or disparagement of classes of individuals. Consequence : A permanent ban from any sort of public interaction within the community.","ref":"code_of_conduct.html#enforcement-guidelines","title":"Code of Conduct - Enforcement Guidelines","type":"extras"},{"doc":"This Code of Conduct is adapted from the Contributor Covenant , version 2.0, available at https://www.contributor-covenant.org/version/2/0/code_of_conduct.html. Community Impact Guidelines were inspired by Mozilla's code of conduct enforcement ladder . For answers to common questions about this code of conduct, see the FAQ at https://www.contributor-covenant.org/faq. Translations are available at https://www.contributor-covenant.org/translations.","ref":"code_of_conduct.html#attribution","title":"Code of Conduct - Attribution","type":"extras"}]